/*
 * Common Attributes for shaders (include a fixed number of lights, their attributes
 * and common material atrributes of the shaded material.
 * includes default values
 * 
 * light positions are in worldspace
 */ 

float4x4 WorldIT : WorldInverseTranspose;
float4x4 WorldViewProj : WorldViewProjection;
float4x4 World : World;
float4x4 ViewInv : ViewInverse;

float3 LightPos = {.0f, 9.0f, .0f};
float4 LightColor = {1.0f, 1.0f, 1.0f, 1.0f};
float LightIntensity = .6f;

//material

float4 AmbiColor : Ambient = {0.2f, 0.2f, 0.2f, 1.0f};
float SpecExpon : SpecularPower = 50.0;

//VSDCT - Parameter
float4   cLightQ;                       // [ Zf/(Zf-Zn), ZnZf/(Zf-Zn), 0, 0 ]

//VARS FOR DEPTh OF FIELD
//{ Near Blur Depth, Focal Plane Depth, Far Blur Depth, Bluriness Cutoff > Focal }
//are set dynamically
//float4 dofParams = { 1.291f, 2.0f, 4.30f, 1.0f };

float4 dofParams; // x = 1/(focusplanes - nearplanes), y = 1(farplane - focusplane),z = FocusPlan, w = clamp

//Addtional SPecular Color 
float4 specularColor;

//Common Samplers

sampler2D shadowMapVSDCT = sampler_state {
	CompareFunc = LEqual;
	CompareMode = CompareRToTexture;
	//DepthMode= Luminance;
	generateMipMap = false;
	MinFilter = Linear;
	MagFilter = Linear;
	WrapS = ClampToEdge;
	WrapT = ClampToEdge;
};

samplerCUBE indirectionSampler = sampler_state {
	GenerateMipMap = false;
	MinFilter = Linear;
	MagFilter = Linear;
	WrapS = ClampToEdge;
	WrapT = ClampToEdge;
};

samplerCUBE indirectionEdgeSampler = sampler_state {
	GenerateMipMap = false;
	MinFilter = Linear;
	MagFilter = Linear;
	WrapS = ClampToEdge;
	WrapT = ClampToEdge;
};

sampler2D colorSampler = sampler_state {
	generateMipMap = false;
	/*MinFilter = LinearMipMapLinear;
	MagFilter = Linear;*/
	WrapS = Repeat;
	WrapT = Repeat;
	MaxAnisotropy = 16;
};